<?php
/*
  $Id$

  Modified for modules control Version 1.2.0
  by @raiwa Rainer Schmied / info@oscaddons.com  / www.oscaddons.com
  
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2017 osCommerce

  Released under the GNU General Public License
*/

  class oscTemplate {
    var $_title;
    var $_blocks = array();
    var $_content = array();
    var $_grid_container_width = 12;
    var $_grid_content_width = BOOTSTRAP_CONTENT;
    var $_grid_column_width = 0; // deprecated
    var $_data = array();
    var $_hide_column = false; // modules control

    function __construct() {
      $this->_title = TITLE;
    }

    function setGridContainerWidth($width) {
      $this->_grid_container_width = $width;
    }

    function getGridContainerWidth() {
      return $this->_grid_container_width;
    }

    function setGridContentWidth($width) {
      $this->_grid_content_width = $width;
    }

// BOF modules control
    function getGridContentWidth() {
      if ( $this->_hide_column == true ) {
        return MODULE_CONTROL_CONTENT_WIDTH;
      } else {
        return $this->_grid_content_width;
      }
    }
// EOF modules control

    function setGridColumnWidth($width) {
      $this->_grid_column_width = $width;
    }

// BOF modules control
    function getGridColumnWidth() {
      if ( $this->_hide_column == true ) {
        return (12 - MODULE_CONTROL_CONTENT_WIDTH) / 2;
      } else {
        return (12 - BOOTSTRAP_CONTENT) / 2;
      }
    }
// EOF modules control

    function setTitle($title) {
      $this->_title = $title;
    }

    function getTitle() {
      return $this->_title;
    }

    function addBlock($block, $group) {
      $this->_blocks[$group][] = $block;
    }

// BOF modules control
    function hasBlocks($group) {
      return ( (isset($this->_blocks[$group]) && !empty($this->_blocks[$group])) || (strpos('boxes_column', $group) === true && $this->_hide_column == true) );
    }

    function getBlocks($group) {
      if ( strpos($group, 'boxes_column') !== false && $this->_hide_column == true ) {
        return '&nbsp;';
      } elseif ($this->hasBlocks($group)) {
        return implode("\n", $this->_blocks[$group]);
      }
    }
// EOF modules control

    function buildBlocks() {
      global $PHP_SELF, $language; // modules control

      if ( defined('TEMPLATE_BLOCK_GROUPS') && tep_not_null(TEMPLATE_BLOCK_GROUPS) ) {
        $tbgroups_array = explode(';', TEMPLATE_BLOCK_GROUPS);
        foreach ($tbgroups_array as $group) {
          $module_key = 'MODULE_' . strtoupper($group) . '_INSTALLED';

          if ( defined($module_key) && tep_not_null(constant($module_key)) ) {
            $modules_array = explode(';', constant($module_key));

            foreach ( $modules_array as $module ) {
              $class = basename($module, '.php');
              if ( !class_exists($class) ) {
                if ( file_exists('includes/languages/' . $language . '/modules/' . $group . '/' . $module) ) {
                  include('includes/languages/' . $language . '/modules/' . $group . '/' . $module);
                }

                if ( file_exists('includes/modules/' . $group . '/' . $module) ) {
                  include('includes/modules/' . $group . '/' . $module);
                }
              }
              if ( class_exists($class) ) {
                $mb = new $class();
                if ( $mb->isEnabled() && !in_array(basename($PHP_SELF), $this->checkPages($class)) ) { // modules control
                  $mb->execute();
                }
              }
            }
          }
        }
      }
    }


    function addContent($content, $group) {
      $this->_content[$group][] = $content;
    }

    function hasContent($group) {
      return (isset($this->_content[$group]) && !empty($this->_content[$group]));
    }

    function getContent($group) {
      global $PHP_SELF, $language; // modules control

      if ( !class_exists('tp_' . $group) && file_exists('includes/modules/pages/tp_' . $group . '.php') ) {
        include('includes/modules/pages/tp_' . $group . '.php');
      }

      if ( class_exists('tp_' . $group) ) {
        $template_page_class = 'tp_' . $group;
        $template_page = new $template_page_class();
        $template_page->prepare();
      }

      foreach ( $this->getContentModules($group) as $module ) {
        if ( !class_exists($module) ) {
          if ( file_exists('includes/modules/content/' . $group . '/' . $module . '.php') ) {
            if ( file_exists('includes/languages/' . $language . '/modules/content/' . $group . '/' . $module . '.php') ) {
              include('includes/languages/' . $language . '/modules/content/' . $group . '/' . $module . '.php');
            }

            include('includes/modules/content/' . $group . '/' . $module . '.php');
          }
        }

        if ( class_exists($module) ) {
          $mb = new $module();
           if ( $mb->isEnabled() && !in_array(basename($PHP_SELF), $this->checkPages($module)) ) { // modules control
            $mb->execute();
          }
        }
      }

      if ( class_exists('tp_' . $group) ) {
        $template_page->build();
      }

      if ($this->hasContent($group)) {
        return implode("\n", $this->_content[$group]);
      }
    }

    function getContentModules($group) {
      $result = array();

      foreach ( explode(';', MODULE_CONTENT_INSTALLED) as $m ) {
        $module = explode('/', $m, 2);

        if ( $module[0] == $group ) {
          $result[] = $module[1];
        }
      }

      return $result;
    }
    
// BOF modules control
    function checkPages($class){ //$class what is called in the buildblocks and content modules ($module) 
      global $PHP_SELF;
      $modules_exclude_array[$class] = array();
      $modules_exclude_query = tep_db_query('select controlled_module, page_list from modules_control where controlled_module not like "nb_%"');
      while ($modules_exclude = tep_db_fetch_array($modules_exclude_query)) {
        $modules_exclude_array[$modules_exclude['controlled_module']] = explode(',', $modules_exclude['page_list']);
      }
      // check if side columns are empty
      if (in_array(basename($PHP_SELF), $modules_exclude_array[$class])) {
        $this->_hide_column = count(array_intersect(array_keys($modules_exclude_array), str_replace('.php', '', explode(';', MODULE_BOXES_INSTALLED)))) == count(explode(';', MODULE_BOXES_INSTALLED));
      }
      return $modules_exclude_array[$class];
    }
// EOF modules control
    
  }
?>
