<?php
/*
  $Id$ modules_control_class.php
  $loc$ admin/includes/functions/
  
  Modules Control Version 1.2.0
  by @raiwa // Rainer Schmied // info@oscaddons.com // www,oscaddons.com


  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2017 osCommerce

  Released under the GNU General Public License
*/
class modules_control_class {
  
  var $_files_array;
  var $_controlled_pages_array;
  var $_inst_array;
  var $_modules_exclude_array;
  
  function __construct() {
    $this->_files_array = $this->get_files();
    $this->_controlled_pages_array = defined('MODULE_CONTROL_PAGES')? explode(',', MODULE_CONTROL_PAGES): array();
    $this->_inst_array = $this->get_inst_modules();  
    $this->_modules_exclude_array = $this->get_excl_modules();
    // check if any page file has been removed
    $this->check_pages();
  }

// get array of all .php files in the store root directory
// exclude files which never show as a page
  function get_files() {
    global $PHP_SELF;
    $excluded_files_array = array('checkout_process.php',
                                  'download.php',
                                  'redirect.php');    
    
    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
    if ($dir = @dir(DIR_FS_CATALOG)) {
      while ($file = $dir->read()) {
        if (!is_dir(DIR_FS_CATALOG . $file)) {
          if ( substr($file, strrpos($file, '.')) == $file_extension && !in_array($file, $excluded_files_array) ) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }
      return $files_array;
  }

// get structured array of installed modules
  function get_inst_modules() {
    $content_modules_array = explode(';', MODULE_CONTENT_INSTALLED);
    foreach ($content_modules_array as $content_module) {
      switch ($content_module){
      case strpos($content_module, 'header/cm_header_') !== false :
          $header_modules_array[] = str_replace('header/', '', $content_module);
          break;
      case strpos($content_module, 'footer/cm_footer_') !== false :
          $footer_modules_array[] = str_replace('footer/', '', $content_module);
          break;
      case strpos($content_module, 'footer_suffix/cm_footer_extra_') !== false :
          $footer_extra_modules_array[] = str_replace('footer_suffix/', '', $content_module);
          break;
      }
    }
    $inst_array = array('navbar' => str_replace('.php', '', explode(';', MODULE_CONTENT_NAVBAR_INSTALLED)), 
                        'header' => $header_modules_array, 
                        'boxes' => str_replace('.php', '', explode(';', MODULE_BOXES_INSTALLED)), 
                        'footer' => $footer_modules_array, 
                        'footer_extra' => $footer_extra_modules_array);  
    return $inst_array;
  }
  
// get array of modules which have excluded page
  function get_excl_modules() {
    $modules_exclude_array = array();
    $modules_exclude_query = tep_db_query("select controlled_module, page_list from modules_control");
    while ($modules_exclude = tep_db_fetch_array($modules_exclude_query)) {
      $modules_exclude_array[$modules_exclude['controlled_module']] = explode(',', $modules_exclude['page_list']);
    }
    // check if modules have been removed
    if ( isset($modules_exclude_array) ) {
      foreach ($modules_exclude_array as $module=>$pages) {
      // delete removed module from modules_control table
        if ( !$this->in_array_recursive($module, $this->_inst_array) ) tep_db_query("delete from modules_control where controlled_module = '" . $module . "'");
      }
    }
  return $modules_exclude_array;
  }
  
  function in_array_recursive($needle, $haystack) { 
    $it = new RecursiveIteratorIterator(new RecursiveArrayIterator($haystack)); 
    foreach($it AS $element) { 
        if($element == $needle) { 
            return true; 
        } 
    } 
    return false; 
  } 

// check if any page has been removed and clean tables
  function check_pages() {
    $page_removed = false;
    for ($i=0; $i<sizeof($this->_controlled_pages_array); $i++) {
      if (!in_array($this->_controlled_pages_array[$i], $this->get_files())) {
        unset($this->_controlled_pages_array[$i]);
        $page_removed = true;
      }
    }
    tep_db_query("update configuration set configuration_value = '" . tep_db_input(implode(',', $this->_controlled_pages_array)) . "' where configuration_key = '" . 'MODULE_CONTROL_PAGES' . "'");
    if ( isset($this->_modules_exclude_array) && $page_removed == true ) {
      foreach ($this->_modules_exclude_array as $module=>$pages) {
        for ($j=0; $j<sizeof($pages); $j++) {
          if (!in_array($pages[$j], $this->get_files())) {
            unset($pages[$j]);
          }
        }
        if (sizeof($pages) == 0) tep_db_query("delete from modules_control where controlled_module = '" . $module . "'");
        tep_db_query("update modules_control set page_list = '" . tep_db_input(implode(',', $pages)) . "' where controlled_module = '" . $module . "'");
      }
    }
  }
  
} 
?>