<?php
/*
  $Id$ modules_control_config.php
  $loc$ admin/
  
  Modules Control Version 1.2
  by @raiwa // Rainer Schmied // info@oscaddons.com // www,oscaddons.com


  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2014 osCommerce

  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  $action = (isset($_POST['action']) ? $_POST['action'] : '');

  if (tep_not_null($action) && $action == 'update_pages') {
    $pages_array = (isset($_POST['control_file']) ? $_POST['control_file'] : '');
    if (tep_not_null($pages_array)) {
      $pages_array = implode(',', $pages_array);
      tep_db_query("update configuration set configuration_value = '" . tep_db_input($pages_array) . "' where configuration_key = '" . 'MODULE_CONTROL_PAGES' . "'");
    }
      
    $content_width = (isset($_POST['content_width']) ? $_POST['content_width'] : '');
    if ($content_width != '') {
      tep_db_query("update configuration set configuration_value = '" . tep_db_input($content_width) . "' where configuration_key = '" . 'MODULE_CONTROL_CONTENT_WIDTH' . "'");
    }
    $messageStack->add_session(MESSAGE_UPDATE_SUCCESS, 'success');
    tep_redirect(tep_href_link('modules_control_config.php', tep_get_all_get_params(array('control_file', 'content_width', 'action'))));
  } elseif ( tep_not_null($action) && $action == 'install' ) {
    if ( (tep_db_num_rows(tep_db_query("select * from configuration where configuration_key = 'MODULE_CONTROL_PAGES'")) != 1) || (tep_db_num_rows(tep_db_query("select * from configuration where configuration_key = 'MODULE_CONTROL_CONTENT_WIDTH'")) != 1 ) ) {
        tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Module Control Pages', 'MODULE_CONTROL_PAGES', '', 'The pages to control the modules?', '6', '1', now())");
        tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Module Control Content Width', 'MODULE_CONTROL_CONTENT_WIDTH', '8', 'The content width if boxes are hidden?', '6', '1', now())");
        tep_db_query("CREATE TABLE IF NOT EXISTS modules_control (
                      module_id int(4) not null auto_increment,
                      controlled_module VARCHAR(256),
                      page_list TEXT, 
                      PRIMARY KEY (module_id)
                      ) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
    }
    $messageStack->add(MESSAGE_INSTALL_SUCCESS, 'success');
  } elseif ( tep_not_null($action) && $action == 'uninstall' ) {
    tep_db_query("delete from configuration where configuration_key = '" . 'MODULE_CONTROL_PAGES' . "'");
    tep_db_query("delete from configuration where configuration_key = '" . 'MODULE_CONTROL_CONTENT_WIDTH' . "'");
    tep_db_query("drop table if exists modules_control");
    $messageStack->add_session(MESSAGE_DEINSTALL_SUCCESS, 'success');
    tep_redirect(tep_href_link('modules_control.php'));
  }
  
  require('includes/classes/modules_control_class.php');
  $modules_control_class = new modules_control_class;

  require('includes/template_top.php');

?>

<h1 class="pageHeading"><?php echo HEADING_TITLE; ?></h1>

<div style="text-align: center; padding-bottom: 15px;"><?php echo tep_draw_button(IMAGE_MODULES_CONTROL_BACK_TO_MODULES, 'triangle-1-w', tep_href_link('modules_control.php'), 'primary'); ?></div>

 <?php echo tep_draw_form('pages', 'modules_control_config.php', '', 'post'); ?>

  <table border="0" width="100%" cellspacing="0" cellpadding="2">
    <tr class="dataTableHeadingRow">
      <td class="dataTableHeadingContent" align="center" colspan="8"><strong><?php echo TABLE_HEADING_PAGE_NAME; ?></strong></td>
    </tr>
    <?php
      if (isset($modules_control_class->_files_array)) {
        echo '     <tr valign="top">' . "\n" .
             '       <td>' . "\n" . 
             '         <table>' . "\n";
        $i = 0;
        foreach ($modules_control_class->_files_array as $page) {
          echo '           <tr class="dataTableRow">' . "\n" .
               '             <td class="dataTableContent" valign="top">' . $page . '</td>' . "\n" .
               '             <td class="dataTableContent" valign="top">' . tep_draw_checkbox_field('control_file[]', $page, in_array($page, $modules_control_class->_controlled_pages_array)) . '</td>' . "\n" .
               '           </tr>' . "\n";
          if ( ($i+1 == ceil(sizeof($modules_control_class->_files_array) *0.25)) || ($i+1 == ceil((sizeof($modules_control_class->_files_array) *0.5))) || ($i+1 == ceil((sizeof($modules_control_class->_files_array) *0.75))) ) { // new columns
            echo '         </table>' . "\n" .
                 '       </td>' . "\n" . 
                 '       <td>' . "\n" .
                 '         <table>' . "\n";
          }
          $i++;
        }
        echo '         </table>' . "\n";
      }
    ?>
     </td>
   </tr>
 </table>
 <hr>
 <table border="0" width="100%" cellspacing="0" cellpadding="2">
   <tr>
     <td><?php echo TABLE_HEADING_CONTENT_WIDTH . tep_draw_input_field('content_width', defined('MODULE_CONTROL_CONTENT_WIDTH')? MODULE_CONTROL_CONTENT_WIDTH : '8', 'style="width:35px;" max="12"', true, 'number', true); ?></td>
     <td><small><?php echo TABLE_HEADING_CONTENT_WIDTH_INFO; ?></small></td>
   </tr>
   <tr>
     <td colspan="2"><hr></td>
   </tr>
   <tr>
     <td colspan="2" align="center"><?php echo tep_draw_button(IMAGE_UPDATE, 'refresh', null, 'primary') . tep_draw_hidden_field('action', 'update_pages'); ?></td>
   </tr>
 </table>

</form>

<?php echo tep_draw_form('uninstall', 'modules_control_config.php', '', 'post'); ?>
  <div style="text-align: right; padding-right: 15px;"><?php echo '<span><button type="submit" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-icon-secondary ui-priority-secondary" role="button" aria-disabled="false" style="margin-bottom: 5px;" onclick="return confirm(\'' . IMAGE_MODULES_CONTROL_UNINSTALL_CONFIRM . '\');"><span class="ui-button-icon-secondary ui-icon ui-icon-trash"></span><span class="ui-button-text">' . IMAGE_MODULES_CONTROL_UNINSTALL . '</span></button></span>' . tep_draw_hidden_field('action', 'uninstall'); ?></div>
</form>

<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
